--by xyzspain 
-- funciones
--movimiento translacion de cada unidad de sembrado
--movimiento por cilindros de las barras de union
--movimiento de ruedas
--cosecha maiz

Planter = {};

function Planter.prerequisitesPresent(specializations) 

return SpecializationUtil.hasSpecialization(Trailer, specializations);
end;
function Planter:load(xmlFile)
  print("'lua loaded '" );	
   	
	self.setCilindroDirection = SpecializationUtil.callSpecializationsFunction("setCilindroDirection");	
	local cilindrosCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.cilindros#count"), 0);	
	self.cilindros = {};	
	for i=1, cilindrosCount do
		local cilindroName = string.format("vehicle.cilindros.cilindro%d", i);		
		self.cilindros[i] = {};		
		self.cilindros[i].node = Utils.indexToObject(self.components, getXMLString(xmlFile, cilindroName .. "#index"));
		self.cilindros[i].part = Utils.indexToObject(self.components, getXMLString(xmlFile, cilindroName .. "#part"));
		self.cilindros[i].cilindroFixpoint = Utils.indexToObject(self.components, getXMLString(xmlFile, cilindroName .. "#cilindroFixpoint"));
		self.cilindros[i].fixPoint = Utils.indexToObject(self.components, getXMLString(xmlFile, cilindroName .. "#fixpoint"));
		local ax, ay, az = getWorldTranslation(self.cilindros[i].part);
		local bx, by, bz = getWorldTranslation(self.cilindros[i].cilindroFixpoint);		
		self.cilindros[i].partDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);	
	end;	
	print("'0 '" );	
	
	self.rollerNode1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.roller#index1"));
	self.rollerNode2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.roller#index2"));
	self.rollerNode3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.roller#index3"));
	self.rollerNode4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.roller#index4"));
	self.rollerNode5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.roller#index5"));
	self.rollerNode6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.roller#index6"));
	self.rollerNode7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.roller#index7"));
	self.rollerNode8 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.roller#index8"));
	
	self.rollerRotationScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.roller#rotationScale"), 1);
	local workSound = getXMLString(xmlFile, "vehicle.workSound#file");
    if workSound ~= nil and workSound ~= "" then
        workSound = Utils.getFilename(workSound, self.baseDirectory); 
        self.workSound = createSample("workSound");
        self.workSoundEnabled = false;
        loadSample(self.workSound, workSound, false);
        self.workSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.workSound#pitchOffset"), 1);
        self.workSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.workSound#volume"), 1);
    end;
--especificacion cosechas
 self.seeds = {};
    for k, fruitType in pairs(FruitUtil.fruitTypes) do
        if fruitType.allowsSeeding then
            self.seeds[fruitType.index] = fruitType.index;
        end;
    end;
	--especificacion texturas cosechas
 self.fillTypes = {};

    local fruitTypes = getXMLString(xmlFile, "vehicle.fillTypes#fruitTypes");
    if fruitTypes ~= nil then
        local types = Utils.splitString(" ", fruitTypes);
        for k,v in pairs(types) do
            local desc = FruitUtil.fruitTypes[v];
            if desc ~= nil then
                self.fillTypes[desc.index] = true;
            end;
        end;
    end;
 self.currentSeed = 4;
 --movimiento de translacion de un componente o varios, falta tabla, thanks "@author original Manuel Leithner"
	self.lift = {};
	self.lift.minTrans = {Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.lift#minLift"), 0)};
	self.lift.maxTrans = {Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.lift#maxLift"), 0)};
	self.lift.liftTime = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.lift#liftTime"), 3) * 1000;
	self.lift.translimit = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.lift#translimit"));
	print("'1 '" );	
	
	local x,y,z = getTranslation(self.componentJoints[1].jointNode);
	
	self.lift.workingPosition = {x,y,z};
	print("'2 '" );	
	self.lift.currentTransLimit = {0};
	
	self.lift.isDown = false;
	x,y,z = getTranslation(self.lift.translimit);
	setTranslation(self.componentJoints[1].jointNode, x,y,z);
	setJointFrame(self.componentJoints[1].jointIndex, 0, self.componentJoints[1].jointNode);
	setJointTranslationLimit(self.componentJoints[1].jointIndex, 1, true, 0, 0);
	print("'prueba '" );	
	self.lift.prueba = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.lift#prueba")); --nueva variable a otro componente
	local x,y,z = getTranslation(self.componentJoints[2].jointNode);
	self.lift.workingPrueba = {x,y,z}; --para cargar posicion de inicio
	x,y,z = getTranslation(self.lift.prueba); 
	setTranslation(self.componentJoints[2].jointNode, x,y,z);
	setJointFrame(self.componentJoints[2].jointIndex, 0, self.componentJoints[2].jointNode);
	setJointTranslationLimit(self.componentJoints[2].jointIndex, 1, true, 0, 0);
	
	
	
		self.isDown = false;
	print("'3 '" );	
end;

function Planter:delete()

 end;


function Planter:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Planter:keyEvent(unicode, sym, modifier, isDown)
   
	if isDown and sym == Input.KEY_v then	
		self.Go = not self.Go; 
		self.lift.isDown = not self.lift.isDown;
	end;
	
	-- if isDown and sym == Input.KEY_x then	
             -- self.currentSeed = self.currentSeed + 1;
                -- if self.currentSeed > table.getn(self.seeds) then
                    -- self.currentSeed = 1;
                -- end;
           
    -- end;

end;


function Planter:update(dt)

	self.isLowered = false;
	
	if math.abs(self.lift.currentTransLimit[1]) > math.abs(self.lift.maxTrans[1] / 2) then
			self.isLowered = true;
		end;	
	
	
	
	
	
--	play areas y sonido
	if self.attacherVehicle and self.Go then
	 self.currentFillType = self.seeds[self.currentSeed];
	  
	  -- if self.movingDirection > 0 then
         
				local x,y,z = getWorldTranslation(self.cuttingAreas[1].start);
                local x1,y1,z1 = getWorldTranslation(self.cuttingAreas[1].width);
                local x2,y2,z2 = getWorldTranslation(self.cuttingAreas[1].height);
				local areaA = 0;
			if self.currentSeed == 4 then
			areaA = Utils.updateSowingArea(self.seeds[self.currentSeed], x, z, x1, z1, x2, z2);
			else
			areaA = 0;
			end;			
				local x,y,z = getWorldTranslation(self.cuttingAreas[2].start);
                local x1,y1,z1 = getWorldTranslation(self.cuttingAreas[2].width);
                local x2,y2,z2 = getWorldTranslation(self.cuttingAreas[2].height);
				local areaB = 0;
			if self.currentSeed == 4 then
			areaB = Utils.updateSowingArea(self.seeds[self.currentSeed], x, z, x1, z1, x2, z2);
			else
			areaB = 0;
			end;

                -- local fruitDesc = FruitUtil.fruitIndexToDesc[self.seeds[self.currentSeed] ];

                -- local pixelToQm = 2048 / 8192 * 2048 / 8192;
                -- local qm = area*pixelToQm;
                -- local ha = qm/10000;
				-- local speedFactor = self.attacherVehicle.lastSpeed*3600/12;
                -- local usage = fruitDesc.seedUsagePerQm*qm*speedFactor*5;
	
			-- if self.currentSeed == 4 then
                    -- local seedPrice = fruitDesc.seedPricePerLiter*usage;
                    -- g_currentMission.missionStats.expensesTotal = g_currentMission.missionStats.expensesTotal + seedPrice;
                    -- g_currentMission.missionStats.expensesSession = g_currentMission.missionStats.expensesSession + seedPrice;
			-- end;
                -- g_currentMission.missionStats.seedUsageTotal = g_currentMission.missionStats.seedUsageTotal + usage;
                -- g_currentMission.missionStats.seedUsageSession = g_currentMission.missionStats.seedUsageSession + usage;

                -- g_currentMission.missionStats.hectaresSeededTotal = g_currentMission.missionStats.hectaresSeededTotal + ha;
                -- g_currentMission.missionStats.hectaresSeededSession = g_currentMission.missionStats.hectaresSeededSession + ha;

                -- g_currentMission.missionStats.seedingDurationTotal = g_currentMission.missionStats.seedingDurationTotal + dt/(1000*60);
                -- g_currentMission.missionStats.seedingDurationSession = g_currentMission.missionStats.seedingDurationSession + dt/(1000*60);

	-- end; 	
		
			if self.attacherVehicle.lastSpeed*3600 > 2 then
			if self.rollerNode1 ~= nil then
				rotate(self.rollerNode1, self.rollerRotationScale * self.attacherVehicle.lastSpeed * 0, -1, 0);
			end;
			if self.rollerNode2 ~= nil then
				rotate(self.rollerNode2, self.rollerRotationScale * self.attacherVehicle.lastSpeed * 0, -1, 0);
			end;
			if self.rollerNode3 ~= nil then
				rotate(self.rollerNode3, self.rollerRotationScale * self.attacherVehicle.lastSpeed * 0, 1, 0);
			end;
			if self.rollerNode4 ~= nil then
				rotate(self.rollerNode4, self.rollerRotationScale * self.attacherVehicle.lastSpeed * 0, 1, 0);
			end;
		if self.rollerNode5 ~= nil then
				rotate(self.rollerNode5, self.rollerRotationScale * self.attacherVehicle.lastSpeed * 0, -1, 0);
			end;
			if self.rollerNode6 ~= nil then
				rotate(self.rollerNode6, self.rollerRotationScale * self.attacherVehicle.lastSpeed * 0, -1, 0);
			end;
			if self.rollerNode7 ~= nil then
				rotate(self.rollerNode7, self.rollerRotationScale * self.attacherVehicle.lastSpeed * 0, 1, 0);
			end;
			if self.rollerNode8 ~= nil then
				rotate(self.rollerNode8, self.rollerRotationScale * self.attacherVehicle.lastSpeed * 0, 1, 0);
			end;
			if not self.workSoundRunning then
                print("start");
                playSample(self.workSound, 0, 1.6, 0);
                self.workSoundRunning = true;
			end;
			end;
			if self.attacherVehicle.lastSpeed*3600 < 2 then
			if self.workSoundRunning then
                print("end");
                stopSample(self.workSound, 0, 1.6, 0);
                self.workSoundRunning = false;
			end;
			end;
			-- end;
			else
			
			if self.workSoundRunning then
                print("end");
                stopSample(self.workSound, 0, 1.6, 0);
                self.workSoundRunning = false;
			end;
	
	end;

	--rotaciones y translaciones

		local newTransLimit = Utils.getMovedLimitedValues(self.lift.currentTransLimit, self.lift.maxTrans, self.lift.minTrans, 1, self.lift.liftTime, dt, not self.lift.isDown);
	
		print("'4 '" );	
		if math.abs(newTransLimit[1] * 100 - self.lift.currentTransLimit[1]*100) > 0.001 then			
			setJointTranslationLimit(self.componentJoints[1].jointIndex, 1, true, -newTransLimit[1], 0);
			setJointTranslationLimit(self.componentJoints[2].jointIndex, 1, true, -newTransLimit[1], 0);
			end;
			
			
		self.lift.currentTransLimit = newTransLimit;			
				
		print("'6 '" );		
					
					
					
					
	-- juntas
	local joint = self.componentJoints[1];
			setJointFrame(joint.jointIndex, 0,joint.jointNode);
		local joint = self.componentJoints[2];
			setJointFrame(joint.jointIndex, 0,joint.jointNode);
	
	 
		self:setCilindroDirection();
 
end;


function Planter:draw()
-- g_currentMission.fruitOverlays[self.currentFillType]:render();




end;


function Planter:onAttach()	
		setTranslation(self.componentJoints[1].jointNode, unpack(self.lift.workingPosition));
	setJointFrame(self.componentJoints[1].jointIndex, 0, self.componentJoints[1].jointNode);
	setTranslation(self.componentJoints[2].jointNode, unpack(self.lift.workingPrueba));
	setJointFrame(self.componentJoints[2].jointIndex, 0, self.componentJoints[2].jointNode);
	self.isDown = false;
end;

function Planter:onDetach()
	local x,y,z = getTranslation(self.lift.translimit);--vuelve a la translacion de origen
	setTranslation(self.componentJoints[1].jointNode, x,y,z);
	setJointFrame(self.componentJoints[1].jointIndex, 0, self.componentJoints[1].jointNode);
	setJointTranslationLimit(self.componentJoints[1].jointIndex, 1, true, 0, 0);
	local x,y,z = getTranslation(self.lift.prueba);--vuelve a la translacion de origen
	setTranslation(self.componentJoints[2].jointNode, x,y,z);
	setJointFrame(self.componentJoints[2].jointIndex, 0, self.componentJoints[2].jointNode);
	setJointTranslationLimit(self.componentJoints[2].jointIndex, 1, true, 0, 0);
	
	
   if self.workSoundRunning then
               
                stopSample(self.workSound, 0, 1.6, 0);
                self.workSoundRunning = false;
	end;

end;


function Planter:setCilindroDirection()

	for i=1, table.getn(self.cilindros) do
		local ax, ay, az = getWorldTranslation(self.cilindros[i].node);
		local bx, by, bz = getWorldTranslation(self.cilindros[i].fixPoint);
		local x, y, z = worldDirectionToLocal(getParent(self.cilindros[i].node), bx-ax, by-ay, bz-az);
		
		setDirection(self.cilindros[i].node, x, y, z, 0, 1, 0);
		if self.cilindros[i].part ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
				setTranslation(self.cilindros[i].part,0 ,0 ,distance-self.cilindros[i].partDistance);
		end;	
	end;
end;





